"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.call = exports.config = exports.commands = exports.options = exports._prompts = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _prompts2 = require("prompts");

var _prompts3 = _interopRequireDefault(_prompts2);

var _yargsParser = require("yargs-parser");

var _yargsParser2 = _interopRequireDefault(_yargsParser);

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isArray = Array.isArray;
var entries = Object.entries;


var rootAlias = "_";
var commandRegex = /\.*[\][<>]/g;
var genSpace = function genSpace(space, fill) {
  return Array.from(new Array(space - fill)).join(" ");
};
var useInit = {
  CLI: {
    options: {
      v: {
        alias: "version",
        desc: "version"
      },
      h: {
        alias: "help",
        desc: "help"
      }
    },
    commands: {
      _: {
        exec: function exec(_ref) {
          var v = _ref.v,
              version = _ref.CLI.config.version;

          v && console.log(version);
        }
      }
    }
  }
};

var _prompts = exports._prompts = {
  _: function _(_ref2) {
    var _this = this;

    var _ = _ref2._,
        _val = _ref2._val;
    var input = _val.input,
        then = _val.then;

    (0, _prompts3.default)(input).then(function (res) {
      return then({ res: res, _: _, CLI: _this });
    });
  }
};

var options = exports.options = {
  _: function _(_ref3) {
    var _key = _ref3._key,
        _val = _ref3._val,
        cp = _ref3.cp;

    Object.assign(this.options, _val);
  },
  $: function $(_ref4) {
    var _key = _ref4._key,
        _val = _ref4._val,
        cp = _ref4.cp;
    var alias = _val.alias,
        desc = _val.desc;

    var keyLength = _key.length;
    var aliasLength = alias.length;
    var output = "  -" + _chalk2.default.grey(_key) + genSpace(8, keyLength) + "--" + _chalk2.default.grey(alias) + genSpace(28, aliasLength) + _chalk2.default.grey(desc) + "\n";
    this.sugar.optionList.push(output);
  }
};

var commands = exports.commands = {
  $: function $(_ref5) {
    var _key = _ref5._key,
        _val = _ref5._val,
        cp = _ref5.cp;
    var exec = _val.exec,
        _val$args = _val.args,
        args = _val$args === undefined ? [] : _val$args,
        desc = _val.desc;

    this.commands[_key] = _val;
    this.Event.on(_key, exec);
    if (_key !== rootAlias) {
      args = args.map(function (argv) {
        return "[" + argv + "]";
      });
      var keyLength = _key.length;
      var argsLength = args.join(" ").length;
      var output = "  " + _chalk2.default.magenta(_key) + genSpace(8, keyLength) + _chalk2.default.gray(args.join(" ")) + genSpace(30, argsLength) + " " + _chalk2.default.grey(desc) + " \n";
      this.sugar.commandList.push(output);
    }
  }
};

var config = {
  _: function _(_ref6) {
    var _val = _ref6._val;

    Object.assign(this.config, _val);
  },
  start: function start(_ref7) {
    var _this2 = this;

    var _ = _ref7._,
        _val = _ref7._val;
    var target = this.config.target;

    _.$use(useInit);

    var _parser = (0, _yargsParser2.default)(target || process.argv.slice(2)),
        __ = _parser._,
        options = _objectWithoutProperties(_parser, ["_"]);

    var _2 = _toArray(__),
        _$ = _2[0],
        _key = _$ === undefined ? rootAlias : _$,
        _args = _2.slice(1);

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = entries(options)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _ref8 = _step.value;

        var _ref9 = _slicedToArray(_ref8, 2);

        var key = _ref9[0];
        var val = _ref9[1];

        this.args[key] = val;

        var _ref11 = this.options[key] || {},
            alias = _ref11.alias;

        if (alias) {
          this.args[alias] = val;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    var _ref10 = this.commands[_key] || {},
        _ref10$args = _ref10.args,
        args = _ref10$args === undefined ? [] : _ref10$args;

    args.forEach(function (argv, i) {
      _this2.args[argv] = _args[i];
    });
    this.Event.emit(_key, _extends({ _: _, CLI: this }, this.args));
  }
};

exports.config = config;
var call = exports.call = {
  help: function help(_ref12) {
    var _val = _ref12._val;

    console.log("\n" + _chalk2.default.grey("Commands:") + "\n\n" + this.sugar.commandList.join("") + "\n\n" + _chalk2.default.grey("Options:") + "\n\n" + this.sugar.optionList.join("") + "\n    ");
  }
};